<?php

//
// Ce fichier ne sera execute qu'une fois
if (defined("_ECRIRE_INC_AUTH_BDDEXT")) return;
define("_ECRIRE_INC_AUTH_BDDEXT", "1");

class Auth_bddext {
	var $nom, $bio, $email, $nom_site, $url_site, $login, $pass, $statut, $pgp;

	function init() {
		spip_log("entree dans auth_bddext");
		// Verifier la presence de bddext
		if (!$GLOBALS['bddext_present']) return false;
		return spip_connect_bddext();
	}

	function verifier_challenge_md5($login, $mdpass_actuel, $mdpass_futur) {
		return false;
	}

	function verifier($login, $pass) {
		global $bddext_link, $bddext_table, $bddext_champs, $bddext_invalidite, $bddext_type_pass;
		$cond_supp = '';

		// Securite...
		if (!$login || !$pass) return false;

		switch($bddext_type_pass) {
			case 1 : //mot de passe en clair
				$local_pass = $pass;
				break;
			case 2 : //mot de passe en md5 'simple'
				$local_pass = md5($pass);
				break;
			case 3 : //mot de passe en challenge_md5 (spip externe)
				$cond_supp = ', '.$bddext_champs['alea_actuel'].' AS alea'; //Select des alea.
				break;
			case 0 : //pas de mot de passe, pas d'accs ;-)
			default :
				$local_pass = '';
		}

		$cond_supp = ($bddext_invalidite?", ".$bddext_champs['invalide']." AS invalide":"") . $cond_supp;

		$query = "SELECT ".$bddext_champs['login_ext']." AS login_ext, ".$bddext_champs['pass']." AS pass".$cond_supp." FROM ".$bddext_table." WHERE ".$bddext_champs['login_ext']."='".addslashes($login)."'";
		$result = mysql_query($query, $bddext_link);
		if ($row = mysql_fetch_array($result)) {
			if ($bddext_type_pass == 3) $local_pass = md5($row['alea'].$pass);
			if (addslashes($login) == $row['login_ext'] AND $local_pass == $row['pass']) {
				if($bddext_invalidite AND ($row['invalide'] == $bddext_invalidite)) return false;
				$this->login = $login;
				return true;
			}
		}
		return false;
	}

	function lire() {
		global $bddext_link, $bddext_table, $bddext_champs;
		$this->nom = $this->email = $this->bio = $this->nom_site = $this->url_site = $this->pgp = $this->pass = $this->statut = '';

		if (!$this->login) return false;

		// Si l'auteur existe dans la base, y recuperer les infos
		$query = "SELECT * FROM spip_auteurs WHERE login='".addslashes($this->login)."' AND source='bddext'";
		$result = spip_query($query);

		if ($row = spip_fetch_array($result)) {
			$this->nom = $row['nom'];
			$this->bio = $row['bio'];
			$this->email = $row['email'];
			$this->email = $row['nom_site'];
			$this->email = $row['url_site'];
			$this->statut = $row['statut'];
			$this->email = $row['pgp'];
			return true;
		}

		// Lire les infos sur l'auteur depuis la base externe
		$query = "SELECT * FROM ".$bddext_table." WHERE ".$bddext_champs['login_ext']."='".addslashes($this->login)."'";
		$result = mysql_query($query, $bddext_link);

		if ($rows = mysql_fetch_array($result)) {
			if (!$this->nom) $this->nom = $rows[$bddext_champs['nom']];
			if (!$this->bio) $this->bio = $rows[$bddext_champs['bio']];
			if (!$this->email) $this->email = $rows[$bddext_champs['email']];
			if (!$this->bio) $this->nom_site = $rows[$bddext_champs['nom_site']];
			if (!$this->bio) $this->url_site = $rows[$bddext_champs['url_site']];
			if (!$this->bio) $this->pgp = $rows[$bddext_champs['pgp']];
			return true;
		}
		return false;
	}

	function activer() {
		$nom = addslashes($this->nom);
		$bio = addslashes($this->bio);
		$login = addslashes($this->login);
		$email = addslashes($this->email);
		$nom_site = addslashes($this->nom_site);
		$url_site = addslashes($this->url_site);
		$statut = lire_meta("bddext_statut_import");
		$pgp = addslashes($this->pgp);

		if (!$statut) return false;

		// Si l'auteur n'existe pas, l'inserer avec le statut par defaut (defini a l'install)
		$query = "SELECT id_auteur FROM spip_auteurs WHERE login='$login'";
		$result = spip_query($query);
		if (spip_num_rows($result)) return false;

		$query = "INSERT IGNORE INTO spip_auteurs (source, nom, login, email, bio, nom_site, url_site, pgp, statut, pass) ".
			"VALUES ('bddext', '$nom', '$login', '$email', '$bio', '$nom_site', '$url_site', '$pgp', '$statut', '')";
		return spip_query($query);
	}
}

?>
